// dmsDate.h: interface for the CdmsDate class.
//
//////////////////////////////////////////////////////////////////////
/*
CdmsDate     .
:
  ,     :
	
	-      "1,1,2000"   "02.03.1999". , "2.2.99"  0099 .
		    .:)
		   . CdmsDate a1(1.1.2001);
	-      
		    . a1.SetDay(1); a1.SetMonth(1); a1.SetYear(2000) 
		    a1.SetDate(2,2,1998);
		    a1.SetDateStr("1.1.2001");
		   a1="1.1.2001"  a1=b1,  b1 -     .
	-   
		   day=a1.GetDay(); month=a1.GetMonth(); year=a1.GetYear;
		    char datestr[11]; strcpy(datestr,a1.tstr())
	- . bool b=(CdmsDate)"2.2.2000">"1.2.2000"; if(a1==b1)  b1 -    .
	-  
	    1)  . CdmsDate b1(2.2.2); a1+=b1  CdmsDate a2=a1+b1.      
			   ,        a1
		2)   . CdmsDate a2=a1+n  a1+=n  int n=19  .    
			   n    a1
	- 
		1)   . __  -=. a1-=b1,  CdmsDate b1(3.3.0)   char b1="3.3.0" ( b1-   
			 b1  ).    a1  ,   3     . (  )
		2)      . __  -. int n=a1-b1.  a1 - , b1 -   . (  , 
			   ,    ).   
			__ __ __ __ __ __ __ __
			  3.3.2000  28.2.2000  4 . 
			        .  a1(3.3.2001)-"3.4.2001"=-31
		3)    . a1-=n  CdmsDate a2=a1-n;   ,    n  .
	: 1)   ""  ,  .   2   1.1.2001  3.1.2001   2.1.2001
					     4.1.2001  2.1.2001   3.1.2001.
			   2)     .
			   3)      ( 13.01.1)   Error
			   4)        bool CheckYear(int),         .
 :
		1)     . cin<<"a1="<<a1<<"\r\n"; // a1 -   CdmsDate
		2)     char*   .tstr(). char[11]strdate; strcpy(strdate,a1);// a1-  CdmsDate
		3)        ,      1.1 2001     2.2.2002.
		4)      :) (    .
		5)        ,         (  '-'),    .
:  
email: s_Daemon@yahoo.com

Disclaimers: this software IS DISTRIBUTED "AS IS".  NO WARRANTY OF ANY KIND IS 
      EXPRESSED OR IMPLIED.  YOU USE AT YOUR OWN RISK. THE AUTHOR WILL NOT 
      BE LIABLE FOR DATA LOSS, DAMAGES, LOSS OF PROFITS OR ANY OTHER KIND OF 
      LOSS WHILE USING OR MISUSING THIS SOFTWARE. 
%))
You may use it as you want, in any projects or your programs, but you have leave a link on author in your software.
*/

#if !defined(AFX_DMSDATE_H__2891C787_D157_11D5_AC1F_D06C4FC10000__INCLUDED_)
#define AFX_DMSDATE_H__2891C787_D157_11D5_AC1F_D06C4FC10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "ctype.h"//for isdigit(...)
#include "stdio.h"//for sprintf(...)
class CdmsDate  
{
	friend int operator-(const CdmsDate& a, const CdmsDate& d);
public:
	virtual bool CheckParity();//  .
	CdmsDate();
	CdmsDate(const CdmsDate&);
	CdmsDate(const char*);//     "d[d].m[m].yyyy"
	virtual ~CdmsDate();
	CdmsDate(char tday, char tmonth,int tyear);
	SetDay(char tDay);
	SetMonth(char tMonth);
	SetYear(int tYear);
	void SetDateStr(const char* in);
	void SetDate(char tday, char tmonth,int tyear);
	char GetDay(){return day;}
	char GetMonth(){return month;}
	int  GetYear(){return year;}
	
	bool operator==(const CdmsDate&);
	bool operator!=(const CdmsDate&);
	bool operator>(const CdmsDate&);
	bool operator<(const CdmsDate&);
	bool operator<=(const CdmsDate&);
	bool operator>=(const CdmsDate&);
	CdmsDate& operator+=(const CdmsDate&);// ,         . ,     2   3   .
	CdmsDate& operator-=(const CdmsDate&);//
	CdmsDate& operator+=(int a);//    - 
	CdmsDate& operator-=(int a);//    - 
	struct Error{};
	const char* tstr();
private:
	char day;
	char month;
	int year;
	char tstrbuf[11];
};
bool CheckYear(int year);//,    .
CdmsDate operator+(const CdmsDate& a, const CdmsDate& b);
CdmsDate operator+(const CdmsDate& a, int b);
int operator-(const CdmsDate& a, const CdmsDate& b);//      (a)   (d).    ,   .
CdmsDate operator-(const CdmsDate& a, int d);
//CdmsDate operator-(const CdmsDate& a, const CdmsDate& b);

#endif // !defined(AFX_DMSDATE_H__2891C787_D157_11D5_AC1F_D06C4FC10000__INCLUDED_)
